#!/data/data/com.termux/files/usr/bin/python3

#A = <\Sigma, Q, Q_i, Q_f, \delta>
class DFA:
	def __init__(self, alphabet, states, start, ends, transf):
		self.alphabet = alphabet
		self.states = states
		self.start = start
		self.ends = ends
		self.transf = transf
		self.reset()

	def reset(self):
		self.current = self.start
	
	def read(self, l):
		nq = self.transf(self.current, l)
		print ("> ",str(self.current)," : ",str(l)," --> ", str(nq))
		self.current = nq
	
	def readstr(self, s):
		for l in s:
			self.read(l)

	def success(self):
		return self.current in self.ends

# Test

alph = "abc"

q0,q1,q2 = "q0", "q1", "q2"
states = [q0,q1,q2]

def delta(q, l):
	if q == q0:
		if l == "a":
			return q1
		elif l == "c":
			return q2
	elif q == q1:
		if l == "a":
			return q1
		else:
			return q0
	elif q == q2:
		if l == "c":
			return q1
		elif l == "b":
			return q0
	return q

oto = DFA(alph, states, q0, [q2], delta)
moves = 0
vstates = [q0]
vletters = []

def help():
	print("Jeu de l'automate.")
	print("------------------")
	print()
	print("But du jeu : découvrir les règles")
	print()
	print("{",alph,"} : jouer une lettre")
	print("s : pour afficher votre score en détail")
	print("h : afficher cette aide")
	print("q : quitter la partie")

def score(verbose=False):
	fstate = oto.success()
	if not verbose:
		return (100-moves) * (len(vstates) + len(vletters)) + (100 if fstate else 0)
	print("(+) États visités : ", len(vstates))
	print("(+) Lettres incluses : ", len(vletters))
	print("État final ? ", "Oui (+)" if fstate else "Non (-)" )
	print("(-) Longueur du mot : ", moves)
	print("Total : ", score())

uin = ""
while uin != "q":
	uin = input("Entrez une lettre : ")
	if uin == "q":
		quit()
	elif uin == "s":
		score(True)
	elif uin == "h":
		help()
	else:
		oto.read(uin)
		moves += 1
		if uin not in vletters:
			vletters.append(uin)
		if oto.current not in vstates:
			vstates.append(oto.current)

print ("Score final : ", score())
